-- ud_059_20140624.sql
-- ud_064_20140721.sql
-- ud_065_20140728.sql
-- 73FF1F5E242D6639A2B4EEC767777704

create or alter procedure DROP_MD (
    ID_MD integer)
as
begin
  if (ID_MD > 0) then
  begin
    update KARTA_USL K
    set K.ID_MD = 0
    where (K.ID_MD = :ID_MD);

    update KARTA_USL K
    set K.ID_MD_ASIST = 0
    where (K.ID_MD_ASIST = :ID_MD);

    delete from MD M
    where (M.ID_NPP = :ID_MD);
  end
end;
@

update KARTA_USL K
set K.ID_MD = 0
where (K.ID_MD not in (select MD.ID_NPP
                       from MD));
@

update KARTA_USL K
set K.ID_MD_ASIST = 0
where (K.ID_MD_ASIST not in (select MD.ID_NPP
                             from MD));
@

CREATE TABLE OPERATOR (
    ID_OP   INTEGER,
    FIO     VARCHAR(150)
);
@

COMMIT WORK;
@

CREATE INDEX OPERATOR_IDX1 ON OPERATOR (ID_OP);
@                             

CREATE SEQUENCE NEW_ID_OPERATOR;
@
ALTER SEQUENCE NEW_ID_OPERATOR RESTART WITH 0;
@

INSERT INTO OPERATOR (ID_OP, FIO)
              VALUES (0, ' ');
              @

ALTER TABLE KARTA
    ADD ID_OPERATOR INTEGER;
    @

create or alter procedure DROP_OPERATOR (
    ID_OP integer)
as
begin
  if (ID_OP > 0) then
  begin
    update KARTA K
    set K.ID_OPERATOR = 0
    where K.ID_OPERATOR = :ID_OP;

    delete from OPERATOR OP
    where OP.ID_OP = :ID_OP;
  end
end;
@

CREATE OR ALTER trigger karta_bi0 for karta
active before insert position 0
AS
begin
  new.idk=new.id;
  if (new.id_operator is null) then new.id_operator=0;
end;
@ 

CREATE OR ALTER trigger karta_bu0 for karta
active before update position 0
AS
begin
  if (new.coment_ident='') then new.coment_ident=null;
  if (new.md5_hash='') then new.md5_hash=null;
  new.idk=new.id;
  if (new.id_operator is null) then new.id_operator=0;
end;
@

update KARTA K
set K.ID_OPERATOR = 0
where K.ID_OPERATOR is null;
@

CREATE GLOBAL TEMPORARY TABLE TMP_DS (
    DS_COD    VARCHAR(10),
    DS_NAME   VARCHAR(255),
    DS_DATE   DATE,
    IS_IN_DD  CHAR(1) DEFAULT '0',
    IS_BEGIN  CHAR(1) DEFAULT '0',
    IS_POD    CHAR(1) DEFAULT '0'
) ON COMMIT PRESERVE ROWS;
@

CREATE GLOBAL TEMPORARY TABLE TMP_RISK (
    ID_RISK    INTEGER,
    NAME_RISK  VARCHAR(255),
    IS_FLAG    CHAR(1)
) ON COMMIT PRESERVE ROWS;
@

CREATE GLOBAL TEMPORARY TABLE TMP_TO_TWO (
    ID        INTEGER,
    USL_CODE  VARCHAR(10),
    USL_NAME  VARCHAR(255),
    IS_POK    CHAR(1)
) ON COMMIT PRESERVE ROWS;
@

CREATE GLOBAL TEMPORARY TABLE TMP_USL (
    ID        INTEGER,
    USL_NAME  VARCHAR(255),
    USL_CODE  VARCHAR(10),
    OBYAZ     CHAR(1),
    DATE_OK   DATE,
    MD        INTEGER,
    MD_ASIST  INTEGER,
    ZAB       CHAR(1)
) ON COMMIT PRESERVE ROWS;
@

update KARTA K
set K.MD5_HASH = null,
    K.COMENT_IDENT = null
where (K.DATE_ENTER >= '01.08.2014');
@

COMMIT WORK;
@

CREATE INDEX KARTA_IDX3 ON KARTA (DATE_ENTER);
@
CREATE INDEX KARTA_IDX4 ON KARTA (DR);
@
CREATE INDEX KARTA_IDX5 ON KARTA (NPOLIS);
@
CREATE INDEX TARIF_IDX1 ON TARIF (TD);
@